on startMovie2
  global gPrintObj
  if the machineType <> 256 then
    if factory("RearWindow") = 0 then
      openXLib("REARWIN.XOB")
    end if
    initRearWindow()
    fillWithSpecificColor(255)
  end if
end

on stopMovie2
end

on initRearWindow
  global rwObj
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
  makeObjIfNeeded()
end

on releaseRearWindow
  global rwObj
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
end

on UnCoverDesktop
  global rwObj
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
  unLoad()
end

on makeObjIfNeeded
  global rwObj
  if not objectp(rwObj) then
    set rwObj to RearWindow(mnew, "M")
    if value(rwObj) < 0 then
      alert("System error" && rwObj && "trying to create the RearWindow object in RAM (multiple-monitor config).")
      stopMovie()
      exit
    end if
    if the freeBlock < rwObj(mGetMemoryNeeded) then
      if objectp(rwObj) then
        rwObj(mdispose)
        set rwObj to RearWindow(mnew, "S")
      end if
      if value(rwObj) < 0 then
        alert("System error" && rwObj && "trying to create the RearWindow object in RAM (single-monitor config).")
        stopMovie()
        exit
      end if
    end if
  end if
end

on fillWithIndexColor
  global rwObj
  makeObjIfNeeded()
  set patVar to 255
  rwObj(mIndexColorToWindow, patVar)
end

on fillWithSpecificColor whichColor
  global rwObj
  if the machineType <> 256 then
    makeObjIfNeeded()
    if whichColor = 0 then
      rwObj(mPatToWindow, -1)
    else
      if whichColor = 255 then
        rwObj(mPatToWindow, -5)
      else
        rwObj(mIndexColorToWindow, whichColor)
      end if
    end if
  end if
end
